function freqPatterns = aprioriFPM(data, sMin, initializeWords,...
	expandWords, findSupport, sortedAlphabet, prune)

    freqPatterns = {};

    sortedA = sortedAlphabet(data);
    words0 = initializeWords(sortedA);

    words = {};
    for i = 1:size(words0,2)
        s = findSupport(words0{i}, data);
        words0{i}.support = s;
        if s >= sMin
            words{end+1} = words0{i};
        end
    end

    % we repeat this loop as long as new frequent patterns are found
    while ~isempty(words)
        for i = 1:size(words,2)
            freqPatterns{end+1} = words{i};
        end
        wordCand = expandWords(words,sortedA)
        % checks if all subsequences are frequent (i.e. present in words)
        wordCand = prune(words, wordCand);

        words = {};
        for i = 1:length(wordCand)
            s = findSupport(wordCand{i},data);
            wordCand{i}.support = s;
            if s>=sMin
                words{end+1} = wordCand{i};
            end
        end
    end
end